/*
 * Nv: Krajcsovszki Gergely
 * ETR azonost: KRGRAAT.SZE
 * Kabinetes azonost: h962001
 *
 * Tanya: falak, tet, tornc, ablak, ajt     			1 p
 * Krnyezet: talaj, kerts, gmeskt, vly, kocsi    1 p
 * Idzt s mozgs: kapu nyits-csuks, malac mozog	2 p
 * Men s felirat: men jobb egr gombra mkdik,
 * 							felirat F1-re kapcsolhat	1 p
 */

// #include <GL/glut.h> // from global.h
// #include <math.h>
// #include <stdio.h>

#include "global.h"
#include "animations.h"
#include "map.h"
#include "drawing.h"

#define STEP_SMALL 1
#define STEP_NORMAL 8

static int MenuID, FillMenu, CullMenu, ProjectionMenu;
GLsizei scrW, scrH;
void updateOrtho();
void updatePerspective();

boolean wireframe = FALSE;
boolean cull = FALSE;
boolean drawtext = TRUE;
boolean drawbounds = FALSE;
boolean perspective = TRUE;

int nRange = 800.0f;
double quality = 1.0; // externed at global.h

GLfloat xRot = 0.0f;
GLfloat yRot = 0.0f;
GLfloat xPos = 0.0f;
GLfloat zPos = 600.0f;

void BitmapText( GLfloat x, GLfloat y, char *string )
{
  int len, i;
  glRasterPos2f( x, y );
  len = (int) strlen ( string );
  for ( i = 0; i < len; i++ ){
    glutBitmapCharacter ( GLUT_BITMAP_HELVETICA_18, string[i] );
  }
}

/*
 * sets everything to default.
 * can be used for setup and reset
 */
void setDefaults() {
	buildMap();
	resetAnimations();
	
	wireframe = FALSE;
	cull = FALSE;
	drawtext = TRUE;
	drawbounds = FALSE;

	nRange = 800.0f;

	xRot = 0.0f;
	yRot = 0.0f;
	xPos = 0.0f;
	zPos = 600.0f;
	
	quality = 1.0;
	
	if(perspective) {
		xRot -= 15.0;
		zPos += 350.0;
	}
	
	startPig();
}

void drawText() {
	glColor3f(1.0, 1.0, 0.0);
	
	BitmapText(-nRange, nRange-(nRange/20.0),	"Krajcsovszki Gergely");
	BitmapText(-nRange, nRange-(2*nRange/20.0),	"KRGRAAT.SZE");
	BitmapText(-nRange, nRange-(3*nRange/20.0),	"h962001");
	BitmapText(-nRange, nRange-(4*nRange/20.0),	"Programtervezo informatikus BSc");
	BitmapText(-nRange, nRange-(5*nRange/20.0),	"2011/12 - I");
	
	
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(nRange/20.0),	"Szoveg ki/be - F1");
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(2*nRange/20.0),	"Drotvaz, megjelenites - jobb egergomb");
	
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(4*nRange/20.0),	"Kapu nyitas - F5");
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(5*nRange/20.0),	"Kapu csukas - F6");
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(6*nRange/20.0),	"Malac megijesztese - F7");
	
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(8*nRange/20.0),	"Reset - F9");
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(9*nRange/20.0),	"Minoseg novelese - F10");
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(10*nRange/20.0),	"Minoseg csokkentese - F11");
	
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(12*nRange/20.0),	"Mozgas - nyilak");
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(13*nRange/20.0),	"Forgas - SHIFT + nyilak");
	BitmapText(+nRange/2.0-(nRange/20.0), nRange-(14*nRange/20.0),	"Finom mozgatasok - CTRL");
}

// Called to draw scene
void RenderScene(void)
{
  // Clear the window with current clearing color
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glPolygonMode(GL_FRONT_AND_BACK, (wireframe ? GL_LINE : GL_FILL));
  
  if(cull)
	glEnable(GL_CULL_FACE);
  else
	glDisable(GL_CULL_FACE);
	
  if(drawtext)
	drawText();

	glPushMatrix();
		if(!perspective) {  
			glRotatef(xRot, 1.0f, 0.0f, 0.0f);
			glRotatef(yRot, 0.0f, 1.0f, 0.0f);
			  
			glTranslatef(xPos, 0.0, 0.0);
		}

		drawMap(); // map.h
		  
		if(drawbounds) {
			glTranslatef(0.0, 300.0, 0.0);
			drawBounds();
		}
	glPopMatrix();
  
  // Flush drawing commands
  glutSwapBuffers();
}

// This function does any needed initialization on the rendering
// context. 
void SetupRC()
{
  // Black background
  glClearColor(0.0f, 0.0f, 0.0f, 1.0f );
  glEnable(GL_DEPTH_TEST);
  //buildMap(); // map.h
  setDefaults(); // this builds the map too
}

void SpecialKeys(int key, int x, int y)
{
  // ...
  int state = glutGetModifiers();
  
	if(state & GLUT_ACTIVE_SHIFT) {
		switch(key) {
			case GLUT_KEY_UP:
				if(state & GLUT_ACTIVE_CTRL) {
					xRot -= STEP_SMALL;
				} else {
					xRot -= STEP_NORMAL;
				}
				break;
			case GLUT_KEY_DOWN:
				if(state & GLUT_ACTIVE_CTRL) {
					xRot += STEP_SMALL;
				} else {
					xRot += STEP_NORMAL;
				}
				break;
			case GLUT_KEY_LEFT:
				if(state & GLUT_ACTIVE_CTRL) {
					yRot -= STEP_SMALL;
				} else {
					yRot -= STEP_NORMAL;
				}
				break;
			case GLUT_KEY_RIGHT:
				if(state & GLUT_ACTIVE_CTRL) {
					yRot += STEP_SMALL;
				} else {
					yRot += STEP_NORMAL;
				}
				break;
		}
	} else {
		switch(key) {
			case GLUT_KEY_F1: 
				drawtext = !drawtext; 
				break;
				
			case GLUT_KEY_F5:
				openGate();
				break;
				
			case GLUT_KEY_F6:
				closeGate();
				break;
				
			case GLUT_KEY_F7:
				nudgePig();
				break;
				
			case GLUT_KEY_F9:
				setDefaults();
				break;
			
			case GLUT_KEY_F10:
				quality += 0.05;
				if(quality > 5.0) quality = 5.0;
				break;
			case GLUT_KEY_F11:
				quality -= 0.05;
				if(quality < 0.05) quality = 0.05;
				break;
			/*	
			case GLUT_KEY_F10:
				startPig();
				break;
			case GLUT_KEY_F11:
				stopPig();
				break;
			*/	
			case GLUT_KEY_UP:
				if(state & GLUT_ACTIVE_CTRL) {
					zPos -= STEP_SMALL * cos(yRot/180.0*GL_PI);
					xPos -= STEP_SMALL * sin(yRot/180.0*GL_PI);
					if(!perspective) {
						nRange /= 1 + (STEP_SMALL/10.0);
					}
				} else {
					zPos -= STEP_NORMAL * cos(yRot/180.0*GL_PI);
					xPos -= STEP_NORMAL * sin(yRot/180.0*GL_PI);
					if(!perspective) {
						nRange /= 1 + (STEP_NORMAL/10.0);
					}
				}
				break;
				
			case GLUT_KEY_DOWN:
				if(state & GLUT_ACTIVE_CTRL) {
					zPos += STEP_SMALL * cos(yRot/180.0*GL_PI);
					xPos += STEP_SMALL * sin(yRot/180.0*GL_PI);
					if(!perspective) {
						nRange *= 1 + (STEP_SMALL/10.0);
					}
				} else {
					zPos += STEP_NORMAL * cos(yRot/180.0*GL_PI);
					xPos += STEP_NORMAL * sin(yRot/180.0*GL_PI);
					if(!perspective) {
						nRange *= 1 + (STEP_NORMAL/10.0);
					}
				}
				break;
				
			case GLUT_KEY_LEFT:
				if(state & GLUT_ACTIVE_CTRL) {
				
					if(!perspective) {
						xPos += STEP_SMALL;
					} else {
						xPos += STEP_SMALL * cos(yRot/180.0*GL_PI);
						zPos -= STEP_SMALL * sin(yRot/180.0*GL_PI);
					}
					
				} else {
					
					if(!perspective) {
						xPos += STEP_NORMAL;
					} else {
						xPos += STEP_NORMAL * cos(yRot/180.0*GL_PI);
						zPos -= STEP_NORMAL * sin(yRot/180.0*GL_PI);
					}	
				}
				break;
				
			case GLUT_KEY_RIGHT:
				if(state & GLUT_ACTIVE_CTRL) {
				
					if(!perspective) {
						xPos -= STEP_SMALL;
					} else {
						xPos -= STEP_SMALL * cos(yRot/180.0*GL_PI);
						zPos += STEP_SMALL * sin(yRot/180.0*GL_PI);
					}
					
				} else {
					
					if(!perspective) {
						xPos -= STEP_NORMAL;
					} else {
						xPos -= STEP_NORMAL * cos(yRot/180.0*GL_PI);
						zPos += STEP_NORMAL * sin(yRot/180.0*GL_PI);
					}	
				}
				break;
		}
	}
  
  if(xRot > 360.0f)
    xRot -= 360.0f;
  
  if(xRot < 0.0f)
    xRot += 360.0f;
  
  if(yRot > 360.0f)
    yRot -= 360.0f;
  
  if(yRot < 0.0f)
    yRot += 360.0f;

  // Refresh the Window
  if(perspective)
	updatePerspective();
  else
	updateOrtho();
		
  glutPostRedisplay();
}

/*
void Keyboard(unsigned char key, int x, int y)
{
  // ...
  int state;

  printf("Billentyu lenyomva, kodja %c, pozicio (%d,%d). ", key, x, y);
  state = glutGetModifiers();
  if(state & GLUT_ACTIVE_SHIFT)
    printf("SHIFT lenyomva. ");
  if(state & GLUT_ACTIVE_CTRL)
    printf("CTRL lenyomva. ");
  if(state & GLUT_ACTIVE_ALT)
    printf("ALT lenyomva. ");
  printf("\n");
  fflush(stdout);

  glutPostRedisplay();
}
*/

void Timer(int value)
{
  Tick(); // animations.h

  glutPostRedisplay();
  glutTimerFunc(100, Timer, value + 1);
}

void updateOrtho()
{  
  // Prevent a divide by zero
  if(scrH == 0)
    scrH = 1;
  
  // Set Viewport to window dimensions
  glViewport(0, 0, scrW, scrH);
  
  // Reset projection matrix stack
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  // Establish clipping volume (left, right, bottom, top, near, far)
  if (scrW <= scrH) 
    glOrtho (-nRange, nRange, -nRange*scrH/scrW, nRange*scrH/scrW, -2.0*nRange, 2.0*nRange);
  else 
    glOrtho (-nRange*scrW/scrH, nRange*scrW/scrH, -nRange, nRange, -2.0*nRange, 2.0*nRange);
  
  // Reset Model view matrix stack
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void updatePerspective()
{
  GLfloat fAspect;
  
  // Prevent a divide by zero
  if(scrH == 0)
    scrH = 1;
  
  // Set Viewport to window dimensions
  glViewport(0, 0, scrW, scrH);
  
  fAspect = (GLfloat)scrW/(GLfloat)scrH;
  
  // Reset coordinate system
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  
  // Produce the perspective projection
  gluPerspective(
		60.0f,    // fovy
		fAspect,  // aspect
		10.0,     // zNear
		1500.0    // zFar
	);
  gluLookAt(
		-xPos, 									5.0,							zPos,															// eye
	    -xPos + 100.0 * sin(yRot/180.0*GL_PI) * cos(xRot/180.0*GL_PI),	-100.0 * sin(xRot/180.0*GL_PI),	zPos - 100.0 * cos(xRot/180.0*GL_PI) * cos(yRot/180.0*GL_PI),	// center
	    0.0,									1.0,							0.0																// up
	);
  
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void ChangeSize(GLsizei w, GLsizei h) {
	scrH = h;
	scrW = w;
	
	if(perspective)
		updatePerspective();
	else
		updateOrtho();
}

void ProcessMenu(int value)
{
  switch(value)
    {
    case 101:
      wireframe = FALSE;
      break;
      
    case 102:
      wireframe = TRUE;
      break;
      
    case 201:
      cull = TRUE;
      break;

    case 202:
      cull = FALSE;
      break;
	  
	case 301:
      perspective = FALSE;
	  setDefaults();
      break;

    case 302:
      perspective = TRUE;
	  setDefaults();
      break;
	  
	case 4:
	  drawbounds = !drawbounds;
	  break;

    default:
      break;
    }
  
  if(perspective)
	updatePerspective();
  else
	updateOrtho();
	
  glutPostRedisplay();
}

int main(int argc, char* argv[])
{
  // >> Inicializalas

  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(800, 600);
  glutCreateWindow("Krajcsovszki Gergely");

  // << Inicializalas

  // >> Callback fuggvenyek

  glutReshapeFunc(ChangeSize);

  glutSpecialFunc(SpecialKeys);
  //glutKeyboardFunc(Keyboard);
  glutDisplayFunc(RenderScene);
  glutTimerFunc(100, Timer, 1);
  
  // << Callback fuggvenyek

  // >> Menu

  FillMenu = glutCreateMenu(ProcessMenu);
  glutAddMenuEntry("ON", 101);
  glutAddMenuEntry("OFF", 102);
  
  CullMenu = glutCreateMenu(ProcessMenu);
  glutAddMenuEntry("ON", 201);
  glutAddMenuEntry("OFF", 202);
  
  ProjectionMenu = glutCreateMenu(ProcessMenu);
  glutAddMenuEntry("Ortographical", 301);
  glutAddMenuEntry("Perspective", 302);

  MenuID = glutCreateMenu(ProcessMenu);
  glutAddSubMenu("Polygon filling", FillMenu);
  glutAddSubMenu("Polygon culling", CullMenu);
  glutAddSubMenu("Projection mode", ProjectionMenu);
  glutAddMenuEntry("Toggle drawing bounds", 4);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

  // << Menu

  SetupRC();
  glutMainLoop();
  
  return 0;
}
