#ifndef DRAWING_H
#define DRAWING_H

#include "components.h"

/*
 * Multi-purpose drawing routines
 */
void drawCuboid(Size size);
void drawSphere(Size size, int stacks, int slices);
void drawCylinder(Size size, int sides);
void drawArch(Size size, int sides);
/* 
 * draws a torus with rectangular side. So it looks like a pipe or ring instead of a doughnut
 */
void drawCubicTorus(Size size, GLfloat thickness, int sides);

/*
 * Specific drawing routines
 */
void drawPigEar(Size size);
void drawPigTail(Size size);
void drawRoof(Size size);
void drawWheel(Size size);

/*
 * Helpers
 */
void drawBounds();

#endif /* DRAWING_H */
