#ifndef MAP_H
#define MAP_H

#include "global.h"

#define FIELDSIZE	1350 // size of the field
#define AREASIZE	50 // size of an area, into which the pig may or may not enter
#define FENCECOUNT	13 // number of fenceparts

/*
 * the bounds of the pig's movement
 */ //             z                   x
extern int bounds[FIELDSIZE/AREASIZE][FIELDSIZE/AREASIZE]; // 1 - admitted, 0 - not admitted

/*
 * Build the map from the components. Must be invoked once, in the initialisation state.
 */
void buildMap();

/*
 * Draw the map. This is the main drawing function.
 */
void drawMap();

/*
 * set the bounds of the pig's movements for open gates
 */
void setBoundsOpenGates();

/*
 * set the bounds of the pig's movements for closed gates
 */
void setBoundsClosedGates();

#endif /* MAP_H */